#pragma once

#include "v3.h"
#include "framebuffer.h"

class TMesh {
public:
  V3 *verts;
  int vertsN;
  V3 *colors;
  V3 *normals;
  unsigned int *tris;
  int trisN;
  // triangle t has vertices 
  // (verts[tris[3*t+0]], verts[tris[3*t+1]], verts[tris[3*t+2]])
  TMesh();
  void Load(char *fname);
  void RenderWF(FrameBuffer *fb, PPC *ppc, unsigned int wfc);
  void RenderFilled(FrameBuffer *fb, 
    PPC *ppc, unsigned int meshColor);
  void Translate(V3 trans);
  void Scale(float diag);
  V3 GetCenter();
  AABB GetAABB();
  void SetCenter(V3 newCenter);
};